#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#define MIN(x,y) (x < y ? x : y)

FILE *in;
int caseno;


#define MAXDIM 100 
int grid[MAXDIM][MAXDIM];

int w,h;
int sx,sy,tx,ty;

int mark[2][MAXDIM][MAXDIM];

int search(int x, int y, int c, int dir) { 
  int res;


  if ((x == tx) && (y == ty)) { 
    if ((mark[dir][y][x]==0) || (mark[dir][y][x] > c)) 
      mark[dir][y][x] = c; 

    return 1; 
  } 
  
  if ((x < 0) || (y < 0) || (x > w+1) || (y > h+1)) return 0;

  if ((grid[y][x] != 0)) return 0;

  if ((mark[dir][y][x] > 0) && (mark[dir][y][x] <= c)) return 0;

  /*  printf("%d/%d/%d ",x,y,dir); fflush(0); */

  mark[dir][y][x] = c;

  res = 0;
  res |= search(x,  y-1, c+(dir==1 ? 0 : 1), 1);
  res |= search(x,  y+1, c+(dir==1 ? 0 : 1), 1);
  res |= search(x+1,y,   c+(dir==0 ? 0 : 1), 0);
  res |= search(x-1,y,   c+(dir==0 ? 0 : 1), 0);

  /*  if (res) printf("%d/%d ",x,y); fflush(0); */
  
  return res;
} 


int read_case() { int i; int j; int res; int pair;

  char s[200];

  fscanf(in, "%d %d", &w, &h);

  if ((h==0) && (w == 0)) return 0;

  fgets(s,100, in);

  memset(grid,0,sizeof(grid));

  for (i = 1; i <= h; ++i) { 
    fgets(s,100,in);

    for (j = 0; s[j] != 0; ++j) 
      if (s[j] == 'X') grid[i][j+1] = 1;
  } 

  printf("Board #%d:\n", caseno);
  fscanf(in, "%d %d %d %d", &sx, &sy, &tx, &ty); 

  pair = 1;
  while ((sx != 0) || (sy != 0) || (tx != 0) || (ty != 0)) { 

    memset(mark,0,sizeof(mark));

    printf("Pair %d: ",pair); fflush(0);

    res = 0;
    res |= search(sx,sy-1,1,1);    
    res |= search(sx,sy+1,1,1);    
    res |= search(sx-1,sy,1,0);    
    res |= search(sx+1,sy,1,0);    


    if (res) { 
      res = mark[0][ty][tx];
      if (res == 0) res = mark[1][ty][tx];
      else if (mark[1][ty][tx] != 0) res = MIN(res,mark[1][ty][tx]);

      printf("%d segments.\n", res);
    } 
    else printf("impossible.\n"); 

    fscanf(in, "%d %d %d %d", &sx, &sy, &tx, &ty); 

    pair++;
  } 
  
  printf("\n");
  return 1;
} 

void solve_case() { 
} 

int main() { 

  in = fopen("game.in","r");
  
  for (caseno=1; read_case(); ++caseno) solve_case();

  return 0;
} 
