#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

FILE *in;
int caseno;

#define false 0

#define MAXDIM 100
char E[MAXDIM][MAXDIM+1];

int w,h;

int read_case() { int i;
  char s[200];

  fscanf(in,"%d %d",&w,&h);
  if ((w==0) && (h==0)) return 0;

  fgets(s,100,in);

  for (i = 0; i < h; ++i) fgets(E[i],100,in);

  return 1;
} 



int inv;
int mark[MAXDIM][MAXDIM][4];

int search(int x, int y, int z) { 

  if ((x < 0) || (y < 0) || (x >= w) || (y >= h)) { 
    inv = 1; 
    return 0;
  } 

  if (mark[x][y][z]) return 0;
  mark[x][y][z] = 1; 
  
  if (E[y][x] == '/') { 
    
    if (z == 0) 
      return 
	1 
	+ search(x,y,1) 
	+ search(x,y-1,3); 
    
    if (z == 1) 
      return 
	1 
	+ search(x,y,0) 
	+ search(x-1,y,2); 

    if (z == 2) 
      return 
	1
	+ search(x,y, 3)
	+ search(x+1,y, 1); 

    if (z == 3) 
      return 
	1 
	+ search(x,y, 2)
	+ search(x,y+1, 0); 

    assert(false);
  } 

  if (E[y][x] == '\\') { 

    if (z == 0) 
      return 
	1 
	+ search(x,y,2) 
	+ search(x,y-1,3); 

    if (z == 1) 
      return 
	1 
	+ search(x,y,3)
	+ search(x-1,y,2); 

    if (z == 2) 
      return 
	1
	+ search(x,y,0)
	+ search(x+1,y,1); 

    if (z == 3) 
      return 
	1 
	+ search(x,y,1)
	+ search(x,y+1, 0); 

    assert(false);
  } 

  assert(false);
} 


int max;
int n;

void solve_case() { int x,y,z; int res;

  max = 0;
  n = 0;

  printf("Maze #%d:\n", caseno);

  memset(mark,0,sizeof(mark));

  for (y = 0; y < h; ++y) 
    for (x = 0; x < w; ++x) 
      for (z = 0; z < 4; ++z) { 
	inv = 0; 
	res = search(x,y,z);
	if ((res != 0) && (inv == 0)) { 
	  n++;
	  if (res>max) max = res;
	}
      }


  if (n == 0) printf("There are no cycles.\n\n"); 
  else printf("%d Cycles; the longest has length %d.\n\n",n,max/2); 

} 

int main() { 

  in = fopen("maze.in","r");

  for (caseno=1;read_case(); ++caseno) solve_case();

  return 0;
} 
