
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

FILE *in;

#define MAX 30 

int n;
struct { int y; int a; int b;  int period; } comp[MAX];

int min;

int caseno;

int read_case() {  int i;

  assert(fscanf(in, "%d", &n) == 1);
  if (n == 0) return 0;

  min = 0;

  for (i = 1; i <= n; ++i) { 
    fscanf(in, "%d %d %d", &comp[i].y, &comp[i].a, &comp[i].b); 
    comp[i].period = comp[i].b - comp[i].a;

    if (comp[i].a > min) min = comp[i].a;
  } 

  return 1;
} 


#define MAXY 10000

int possible[MAXY];


void solve_case() { int i,j;

  memset(possible, 0, sizeof(possible));

  printf("Case #%d:\n", caseno);

  for (i = 1; i <= n; ++i) 
    for (j = comp[i].y; j < MAXY; j += comp[i].period) 
      possible[j]++;

  j = -1;
  for (i = min; i < MAXY; ++i) 
    if (possible[i] == n) { j = i; break; } 

  if (j < 0) printf("Unknown bugs detected.\n"); 
  else printf("The actual year is %d.\n", j);
    
  printf("\n");
} 

int main() { 

  in = fopen("y2k.in", "r");
  
  for (caseno=1; read_case(); ++caseno) solve_case();

  return 0;
} 
